<?php

namespace App\Http\Requests\Validators\Operation;

use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rule;
use Validator;

// 企业客户验证器
class BusinessValidator extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        return [
            'title' => 'required|unique:posts|max:255',
            'body' => 'required',
        ];
    }
    // 列表验证器
    public function indexValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'pri_id.required' => '请输入权限id',
            'pri_id.integer' => '参数类型错误',
            'pri_id.min' => '参数类型错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'pri_id' => 'required|integer|min:1',
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 列表验证器
    public function accIndexValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'bucl_id.required' => '请选择企业',
            'bucl_id.integer' => '参数类型错误',
            'bucl_id.min' => '参数类型错误',
            'pri_id.required' => '请输入权限id',
            'pri_id.integer' => '参数类型错误',
            'pri_id.min' => '参数类型错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'bucl_id' => 'required|integer|min:1',
            'pri_id' => 'required|integer|min:1',
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 新增验证器
    public function addValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'bucl_name.required' => '请输入:企业名称',
            'bucl_name.max' => '企业名称长度超过最大限制',
            'bucl_user_name.required' => '请输入:联系人姓名',
            'bucl_user_name.max' => '姓名长度超过最大限制',
            'bucl_user_phone.required' => '请输入:联系人电话',
            'bucl_user_phone.max' => '联系人电话长度超过最大限制',
            // 'bucl_province.required' => '请输入:省',
            // 'bucl_province.max' => '省长度超过最大限制',
            // 'bucl_city.required' => '请输入:市',
            // 'bucl_city.max' => '市长度超过最大限制',
            // 'bucl_county.required' => '请输入:县',
            // 'bucl_county.max' => '县长度超过最大限制',
            // 'bucl_address.required' => '请输入:地址',
            // 'bucl_address.max' => '地址长度超过最大限制',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'bucl_name' => 'required|max:20', //客户姓名
            // 'bucl_user_name' => 'required|max:20', //车主姓名
            // 'bucl_user_phone' => 'required|max:11', //车主电话
            // 'bucl_province' => 'required|max:50',
            // 'bucl_city' => 'required|max:50',
            // 'bucl_county' => 'required|max:50',
            // 'bucl_address' => 'required|max:255'
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 新增账号验证器
    public function addAccountValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'buac_name.required' => '请输入:账号名称',
            'buac_name.max' => '账号名称长度超过最大限制',
            'bucl_id.required' => '请选择企业客户',
            'buac_phone.required' => '请输入:联系人电话',
            'buac_password.required' => '请输入:密码',
            'buac_phone.max' => '联系人电话长度超过最大限制',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'bucl_id' => 'required', //企业客户id
            // 'buac_password' => 'required', //客户密码
            'buac_name' => 'required|max:20', //客户姓名
            'buac_phone' => 'required|max:11', //车主电话
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            $messages = $validator->errors()->all();
            return $messages[0];
        }
    }

    // 删除企业验证器
    public function deleteValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'bucl_id.required' => '参数错误',
            'bucl_id.integer' => '参数错误',
            'bucl_id.min' => '参数错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'bucl_id' => 'required|integer|min:1', //企业客户id
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 删除账号验证器
    public function accdeleteValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'buac_id.required' => '参数错误',
            'buac_id.integer' => '参数错误',
            'buac_id.min' => '参数错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'buac_id' => 'required|integer|min:1', //企业客户id
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 编辑验证器
    public function editValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'bucl_name.required' => '请输入:企业名称',
            'bucl_name.max' => '企业名称长度超过最大限制',
            'bucl_user_name.required' => '请输入:联系人姓名',
            'bucl_user_name.max' => '姓名长度超过最大限制',
            'bucl_user_phone.required' => '请输入:联系人电话',
            'bucl_user_phone.max' => '联系人电话长度超过最大限制',
            // 'bucl_province.required' => '请输入:省',
            // 'bucl_province.max' => '省长度超过最大限制',
            // 'bucl_city.required' => '请输入:市',
            // 'bucl_city.max' => '市长度超过最大限制',
            // 'bucl_county.required' => '请输入:县',
            // 'bucl_county.max' => '县长度超过最大限制',
            // 'bucl_address.required' => '请输入:地址',
            // 'bucl_address.max' => '地址长度超过最大限制',
            'type.required' => '参数错误',
            'type.in' => '参数错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'bucl_name' => 'required|max:20', //客户姓名
            'bucl_user_name' => 'required|max:20', //车主姓名
            'bucl_user_phone' => 'required|max:11', //车主电话
            // 'bucl_province' => 'required|max:50',
            // 'bucl_city' => 'required|max:50',
            // 'bucl_county' => 'required|max:50',
            // 'bucl_address' => 'required|max:255',
            'type' => [
                'required',
                Rule::in(['1', '2']),
            ],
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 编辑验证器
    public function editShowValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'bucl_id.required' => '参数错误',
            'bucl_id.integer' => '参数错误',
            'bucl_id.min' => '参数错误',
            'type.required' => '参数错误',
            'type.in' => '参数错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'bucl_id' => 'required|integer|min:1',
            'type' => [
                'required',
                Rule::in(['1', '2']),
            ],
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 验车查询验证器
    public function validateCarShowValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'ord_id.required' => '参数错误',
            'ord_id.integer' => '参数错误',
            'ord_id.min' => '参数错误',
            'type.required' => '参数错误',
            'type.in' => '参数错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'type' => [
                'required',
                Rule::in(['1', '2']),
            ],
            'ord_id' => 'required|integer|min:1'
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 验车验证器
    public function validateCarValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'ord_id.required' => '参数错误',
            'ord_id.integer' => '参数错误',
            'ord_id.min' => '参数错误',
            'orvc_mileage.required' => '请输入进店里程数',
            'orvc_mileage.integer' => '参数错误',
            'orvc_mileage.min' => '参数错误',
            'orvc_film_roll_number.required' => '请输入膜卷号',
            'orvc_film_roll_number.max' => '参数错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'ord_id' => 'required|integer|min:1',
            'orvc_mileage' => 'required|integer|min:0',
            // 'orvc_film_roll_number' => 'required|max:80',
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 后台签字图片提交验证器
    public function pcsignatureSubmitValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'ord_id.required' => '请输入订单id',
            'ord_id.integer' => '参数类型错误',
            'ord_id.min' => '参数类型错误',
            'img_path.required' => '请传入签字图片路径',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'ord_id' => 'required|integer|min:1',
            'ord_id' => 'required|integer|min:1',
            'img_path' => 'required|max:300',
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 微信用户小程序-列表验证器
    public function indexWashValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'weus_id.required' => '请输入用户id',
            'weus_id.integer' => '参数类型错误',
            'weus_id.min' => '参数类型错误',
            'shop_id.required' => '请输入门店id',
            'shop_id.integer' => '参数类型错误',
            'shop_id.min' => '参数类型错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'weus_id' => 'required|integer|min:1',
            'shop_id' => 'required|integer|min:1',
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 微信用户小程序-详情验证器
    public function infoWashValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'weus_id.required' => '请输入用户id',
            'weus_id.integer' => '参数类型错误',
            'weus_id.min' => '参数类型错误',
            'shop_id.required' => '请输入门店id',
            'shop_id.integer' => '参数类型错误',
            'shop_id.min' => '参数类型错误',
            'ord_id.required' => '请输入订单id',
            'ord_id.integer' => '参数类型错误',
            'ord_id.min' => '参数类型错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'weus_id' => 'required|integer|min:1',
            'shop_id' => 'required|integer|min:1',
            'ord_id' => 'required|integer|min:1',
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 微信用户小程序-详情验证器
    public function reinfoValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'weus_id.required' => '请输入用户id',
            'weus_id.integer' => '参数类型错误',
            'weus_id.min' => '参数类型错误',
            'shop_id.required' => '请输入门店id',
            'shop_id.integer' => '参数类型错误',
            'shop_id.min' => '参数类型错误',
            'reli_id.required' => '请输入订单id',
            'reli_id.integer' => '参数类型错误',
            'reli_id.min' => '参数类型错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'weus_id' => 'required|integer|min:1',
            'shop_id' => 'required|integer|min:1',
            'reli_id' => 'required|integer|min:1',
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 详情验证器
    public function startValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'bucl_id.required' => '请输入企业id',
            'bucl_id.array' => '参数类型错误',
            'bucl_id.min' => '参数类型错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'bucl_id' => 'required|array|min:1',
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 备注验证器
    public function remarkValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'ord_id.required' => '请输入订单id',
            'ord_id.integer' => '参数类型错误',
            'ord_id.min' => '参数类型错误',
            'remark.required' => '请输入备注',
            'remark.max' => '超过最大长度255字符',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'ord_id' => 'required|integer|min:0',
            'remark' => 'required|max:255',
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 预约设置验证器
    public function appointmentSetValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'ord_id.required' => '请输入订单id',
            'ord_id.integer' => '参数类型错误',
            'ord_id.min' => '参数类型错误',
            'appoint_time.required' => '请选择时间',
            'appoint_time.date' => '参数类型错误',
            'appoint_remark.max' => '超过最大长度255字符',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'ord_id' => 'required|integer|min:0',
            'appoint_time' => 'required|date',
            // nullable 验证的字段可以为 null。例如可以包含空值的字符串和整数。
            'appoint_remark' => 'nullable|max:255',
            // 'vacm_type' => [
            //     'required',
            //     Rule::in([1,2]),
            // ],
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 添加作品验证器
    public function addOrderWorksValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'ord_id.required' => '请输入订单id',
            'ord_id.integer' => '参数类型错误',
            'ord_id.min' => '参数类型错误',
            'orwo_title.required' => '请输入标题',
            'orwo_title.max' => '超过最大长度255字符',
            'orwo_type.required' => '请选择类型',
            'orwo_type.in' => '参数类型错误',
            'orwo_data.required' => '请上传作品',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'ord_id' => 'required|integer|min:0',
            'orwo_title' => 'required|max:255',
            'orwo_data' => 'required',
            // nullable 验证的字段可以为 null。例如可以包含空值的字符串和整数。
            'appoint_remark' => 'sometimes|nullable|max:255',
            'orwo_type' => [
                'required',
                Rule::in([1, 2]),
            ],
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 订单作品列表验证器
    public function OrderWorksindexValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'ord_id.required' => '请输入订单id',
            'ord_id.integer' => '参数类型错误',
            'ord_id.min' => '参数类型错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'ord_id' => 'required|integer|min:0',
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 订单作品详情验证器
    public function OrderWorksinfoValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'orwo_id.required' => '请输入订单作品id',
            'orwo_id.integer' => '参数类型错误',
            'orwo_id.min' => '参数类型错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'orwo_id' => 'required|integer|min:0',
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 编辑作品验证器
    public function OrderWorkseditValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'orwo_id.required' => '请输入订单id',
            'orwo_id.integer' => '参数类型错误',
            'orwo_id.min' => '参数类型错误',
            'ord_id.required' => '请输入订单id',
            'ord_id.integer' => '参数类型错误',
            'ord_id.min' => '参数类型错误',
            'orwo_title.required' => '请输入标题',
            'orwo_title.max' => '超过最大长度255字符',
            'orwo_type.required' => '请选择类型',
            'orwo_type.in' => '参数类型错误',
            'orwo_data.required' => '请上传作品',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'orwo_id' => 'required|integer|min:0',
            'ord_id' => 'required|integer|min:0',
            'orwo_title' => 'required|max:255',
            'orwo_data' => 'required',
            // nullable 验证的字段可以为 null。例如可以包含空值的字符串和整数。
            'appoint_remark' => 'sometimes|nullable|max:255',
            'orwo_type' => [
                'required',
                Rule::in([1, 2]),
            ],
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 订单作品删除验证器
    public function OrderWorksdelValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'orwo_id.required' => '请输入作品id',
            'orwo_id.integer' => '参数类型错误',
            'orwo_id.min' => '参数类型错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'orwo_id' => 'required|integer|min:0',
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 订单审核修正验证器
    public function auditOrderValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'ord_id.required' => '请输入作品id',
            'ord_id.integer' => '参数类型错误',
            'ord_id.min' => '参数类型错误',
            'ord_actual_price.required' => '请输入订单金额',
            'ord_actual_price.numeric' => '参数类型错误',
            'ord_actual_price.min' => '参数类型错误',
            // 'orit_service_price.required' => '请输入服务金额',
            // 'orit_service_price.numeric' => '参数类型错误',
            // 'orit_service_price.min' => '参数类型错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'ord_id' => 'required|integer|min:0',
            'ord_actual_price' => 'required|numeric|min:0',
            // 'orit_service_price' => 'required|numeric|min:0',
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 订单历史验证器
    public function getOrderHistoryValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'ord_id.required' => '请输入工单id',
            'ord_id.integer' => '参数类型错误',
            'ord_id.min' => '参数类型错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'ord_id' => 'required|integer|min:1',
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors()->messages();
        }
    }

    // 搜索商品验证器
    public function searchGoodsValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'goo_bra_id.required' => '参数错误',
            'goo_bra_id.integer' => '数据类型不正确',
            'goo_bra_id.min' => '参数错误',
            'goo_cate_id.required' => '参数错误',
            'goo_cate_id.integer' => '数据类型不正确',
            'goo_cate_id.min' => '参数错误',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'goo_bra_id' => 'sometimes|required|integer|min:0',
            'goo_cate_id' => 'sometimes|required|integer|min:0',
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors();
        }
    }

    // 导入验证器
    public function leadValidator($data)
    {
        // 自定义错误消息
        $messages = [
            'file.required' => '请上传文件',
            'file.file' => '请上传文件1',
        ];

        // 数据验证
        $validator = Validator::make($data, [
            'file' => 'required|file',
        ], $messages);

        // 判断数据验证是否成功
        if ($validator->fails()) {
            return $validator->errors();
        }
    }
}
